'' =================================================================================================
''
''   File....... jm_rs485_speed_test.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen
''               Copyright (c) 2013 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 05 JUN 2013
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' QS uses 5MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1    = 31                                                   ' programming / terminal
  TX1    = 30
  
  SDA    = 29                                                   ' eeprom / i2c
  SCL    = 28

  ' connections/io on QuickStart HID Board
  
  K_CLK  = 27                                                   ' ps2 keyboard
  K_DTA  = 26

  M_CLK  = 25                                                   ' ps2 mouse
  M_DTA  = 24

  LED7   = 23                                                   ' leds
  LED6   = 22
  LED5   = 21
  LED4   = 20
  LED3   = 19
  LED2   = 18
  LED1   = 17
  LED0   = 16
  
  VGA    = 16                                                   ' vga base

  VIDEO  = 12                                                   ' composite video base
  
  A_LF   = 11                                                   ' audio pins
  A_RT   = 10

  IR_TX  =  9                                                   ' to ir led
  IR_RX  =  8                                                   ' from ir receiever

  SD_CS  =  3                                                   ' usd 
  SD_DI  =  2 
  SD_CLK =  1 
  SD_DO  =  0
  

con 

  #(-1), IS_ON, IS_OFF
  

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS


obj

  uart1 : "jm_hd485"
  uart2 : "jm_hd485"
  term  : "fullduplexserial"
  

var


pub main | c

  uart1.start(16, 17, -1, -1, 800_000)
  uart2.start(17, 16, -1, -1, 800_000)
  term.start(RX1, TX1, %0000, 115_200)   

  pause(10)

  term.tx(CLS)

  repeat
    uart1.tx_str(string("This is UART1", CR))
    repeat while ((c := uart2.rx_check) => 0)
      term.tx(c)
      
    uart2.tx_str(string("This is UART2", CR))
    repeat while ((c := uart1.rx_check) => 0)
      term.tx(c) 

    pause(500)
    

con

  { --------------- }
  {                 }
  {   B A S I C S   }
  {                 }
  { --------------- }


pub pause(ms) | t

'' Delay program in milliseconds

  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1776                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)
    

pub high(pin)

'' Makes pin output and high

  outa[pin] := 1
  dira[pin] := 1


pub low(pin)

'' Makes pin output and low

  outa[pin] := 0
  dira[pin] := 1


pub toggle(pin)

'' Toggles pin state

  !outa[pin]
  dira[pin] := 1


pub input(pin)

'' Makes pin input and returns current state

  dira[pin] := 0

  return ina[pin]
  

dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}